-- ------------------------------------------------------------------------
-- This file was generated by hibernate for SMP version 4.2-RC2-SNAPSHOT.
-- ------------------------------------------------------------------------


    create table SMP_ALERT (
       ID bigint not null auto_increment comment 'Unique alert id',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        ALERT_LEVEL varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_STATUS varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_STATUS_DESC varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_TYPE varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        MAIL_SUBJECT varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        MAIL_TO varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        PROCESSED_TIME datetime,
        REPORTING_TIME datetime,
        FOR_USERNAME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID)
    ) comment='SMP alerts' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_ALERT_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        ALERT_LEVEL varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_STATUS varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_STATUS_DESC varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        ALERT_TYPE varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        MAIL_SUBJECT varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        MAIL_TO varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        PROCESSED_TIME datetime,
        REPORTING_TIME datetime,
        FOR_USERNAME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_ALERT_PROPERTY (
       ID bigint not null auto_increment comment 'Unique alert property id',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        PROPERTY varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        VALUE varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        FK_ALERT_ID bigint,
        primary key (ID)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_ALERT_PROPERTY_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        PROPERTY varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        VALUE varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        FK_ALERT_ID bigint,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_CERTIFICATE (
       ID bigint not null comment 'Shared primary key with master table SMP_USER',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        CERTIFICATE_ID varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Formatted Certificate id using tags: cn, o, c:serialNumber',
        EXPIRE_LAST_ALERT_ON datetime comment 'Generated last expire alert',
        CRL_URL varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin comment 'URL to the certificate revocation list (CRL)',
        ISSUER varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Certificate issuer (canonical form)',
        PEM_ENCODED_CERT longtext comment 'PEM encoded  certificate',
        SERIALNUMBER varchar(128)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Certificate serial number',
        SUBJECT varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Certificate subject (canonical form)',
        VALID_FROM datetime comment 'Certificate valid from date.',
        VALID_TO datetime comment 'Certificate valid to date.',
        primary key (ID)
    ) comment='SMP user certificates' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_CERTIFICATE_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        CERTIFICATE_ID varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        EXPIRE_LAST_ALERT_ON datetime,
        CRL_URL varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin,
        ISSUER varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        PEM_ENCODED_CERT longtext,
        SERIALNUMBER varchar(128)  CHARACTER SET utf8 COLLATE utf8_bin,
        SUBJECT varchar(1024)  CHARACTER SET utf8 COLLATE utf8_bin,
        VALID_FROM datetime,
        VALID_TO datetime,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_CONFIGURATION (
       PROPERTY varchar(512)  CHARACTER SET utf8 COLLATE utf8_bin not null comment 'Property name/key',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        DESCRIPTION varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Property description',
        VALUE varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Property value',
        primary key (PROPERTY)
    ) comment='SMP user certificates' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_CONFIGURATION_AUD (
       PROPERTY varchar(512)  CHARACTER SET utf8 COLLATE utf8_bin not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        DESCRIPTION varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin,
        VALUE varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (PROPERTY, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_DOMAIN (
       ID bigint not null auto_increment comment 'Unique domain id',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        DOMAIN_CODE varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin not null comment 'Domain code used as http parameter in rest webservices',
        SIGNATURE_KEY_ALIAS varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Signature key alias used for SML integration',
        SML_BLUE_COAT_AUTH bit not null comment 'Flag for SML authentication type - use ClientCert header or  HTTPS ClientCertificate (key)',
        SML_CLIENT_CERT_HEADER varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Client-Cert header used behind RP - ClientCertHeader for SML integration',
        SML_CLIENT_KEY_ALIAS varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Client key alias used for SML integration',
        SML_PARTC_IDENT_REGEXP varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Reqular expresion for participant ids',
        SML_REGISTERED bit not null comment 'Flag for: Is domain registered in SML',
        SML_SMP_ID varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'SMP ID used for SML integration',
        SML_SUBDOMAIN varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'SML subdomain',
        primary key (ID)
    ) comment='SMP can handle multiple domains. This table contains domain specific data' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_DOMAIN_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        DOMAIN_CODE varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        SIGNATURE_KEY_ALIAS varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        SML_BLUE_COAT_AUTH bit,
        SML_CLIENT_CERT_HEADER varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin,
        SML_CLIENT_KEY_ALIAS varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        SML_PARTC_IDENT_REGEXP varchar(4000)  CHARACTER SET utf8 COLLATE utf8_bin,
        SML_REGISTERED bit,
        SML_SMP_ID varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        SML_SUBDOMAIN varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_OWNERSHIP (
       FK_SG_ID bigint not null,
        FK_USER_ID bigint not null,
        primary key (FK_SG_ID, FK_USER_ID)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_OWNERSHIP_AUD (
       REV bigint not null,
        FK_SG_ID bigint not null,
        FK_USER_ID bigint not null,
        REVTYPE tinyint,
        primary key (REV, FK_SG_ID, FK_USER_ID)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_REV_INFO (
       id bigint not null auto_increment,
        REVISION_DATE datetime,
        timestamp bigint not null,
        USERNAME varchar(255)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (id)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_GROUP (
       ID bigint not null auto_increment comment 'Unique ServiceGroup id',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        PARTICIPANT_IDENTIFIER varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin not null,
        PARTICIPANT_SCHEME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID)
    ) comment='Service group data - Identifier and scheme' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_GROUP_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        PARTICIPANT_IDENTIFIER varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        PARTICIPANT_SCHEME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_GROUP_DOMAIN (
       ID bigint not null auto_increment,
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        SML_REGISTERED bit not null,
        FK_DOMAIN_ID bigint,
        FK_SG_ID bigint,
        primary key (ID)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_GROUP_DOMAIN_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        SML_REGISTERED bit,
        FK_DOMAIN_ID bigint,
        FK_SG_ID bigint,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_METADATA (
       ID bigint not null auto_increment comment 'Shared primary key with master table SMP_SERVICE_METADATA',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        DOCUMENT_IDENTIFIER varchar(500)  CHARACTER SET utf8 COLLATE utf8_bin not null,
        DOCUMENT_SCHEME varchar(500)  CHARACTER SET utf8 COLLATE utf8_bin,
        FK_SG_DOM_ID bigint not null,
        primary key (ID)
    ) comment='Service metadata' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_METADATA_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        DOCUMENT_IDENTIFIER varchar(500)  CHARACTER SET utf8 COLLATE utf8_bin,
        DOCUMENT_SCHEME varchar(500)  CHARACTER SET utf8 COLLATE utf8_bin,
        FK_SG_DOM_ID bigint,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_METADATA_XML (
       ID bigint not null,
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        XML_CONTENT longblob comment 'XML service metadata ',
        primary key (ID)
    ) comment='Service group metadata xml blob' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SERVICE_METADATA_XML_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        XML_CONTENT longblob,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SG_EXTENSION (
       ID bigint not null,
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        EXTENSION longblob comment 'XML extension(s) for servicegroup ',
        primary key (ID)
    ) comment='Service group extension blob' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_SG_EXTENSION_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        EXTENSION longblob,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_USER (
       ID bigint not null auto_increment comment 'Unique user id',
        CREATED_ON datetime not null,
        LAST_UPDATED_ON datetime not null,
        ACCESS_TOKEN varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'BCrypted personal access token',
        ACCESS_TOKEN_LAST_ALERT_ON datetime comment 'Generated last access token expire alert',
        ACCESS_TOKEN_EXPIRE_ON datetime comment 'Date when personal access token will expire',
        ACCESS_TOKEN_GENERATED_ON datetime comment 'Date when personal access token was generated',
        ACCESS_TOKEN_ID varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'Personal access token id',
        ACTIVE bit not null comment 'Is user active',
        EMAIL varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'User email',
        LAST_FAILED_LOGIN_ON datetime comment 'Last failed login attempt',
        AT_LAST_FAILED_LOGIN_ON datetime comment 'Last failed token login attempt',
        PASSWORD varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'BCrypted password for username/password login',
        PASSWORD_CHANGED datetime comment 'Last date when password was changed',
        PASSWORD_LAST_ALERT_ON datetime comment 'Generated last password expire alert',
        PASSWORD_EXPIRE_ON datetime comment 'Date when password will expire',
        ROLE varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin comment 'User role',
        LOGIN_FAILURE_COUNT integer comment 'Sequential login failure count',
        AT_LOGIN_FAILURE_COUNT integer comment 'Sequential token login failure count',
        USERNAME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin not null comment 'Unique username identifier. The Username must not be null',
        primary key (ID)
    ) comment='SMP can handle multiple domains. This table contains domain specific data' ENGINE=InnoDB DEFAULT CHARSET=utf8;

    create table SMP_USER_AUD (
       ID bigint not null,
        REV bigint not null,
        REVTYPE tinyint,
        CREATED_ON datetime,
        LAST_UPDATED_ON datetime,
        ACCESS_TOKEN varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        ACCESS_TOKEN_LAST_ALERT_ON datetime,
        ACCESS_TOKEN_EXPIRE_ON datetime,
        ACCESS_TOKEN_GENERATED_ON datetime,
        ACCESS_TOKEN_ID varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        ACTIVE bit,
        EMAIL varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        LAST_FAILED_LOGIN_ON datetime,
        AT_LAST_FAILED_LOGIN_ON datetime,
        PASSWORD varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        PASSWORD_CHANGED datetime,
        PASSWORD_LAST_ALERT_ON datetime,
        PASSWORD_EXPIRE_ON datetime,
        ROLE varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        LOGIN_FAILURE_COUNT integer,
        AT_LOGIN_FAILURE_COUNT integer,
        USERNAME varchar(256)  CHARACTER SET utf8 COLLATE utf8_bin,
        primary key (ID, REV)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    alter table SMP_CERTIFICATE 
       add constraint UK_3x3rvf6hkim9fg16caurkgg6f unique (CERTIFICATE_ID);

    alter table SMP_DOMAIN 
       add constraint UK_djrwqd4luj5i7w4l7fueuaqbj unique (DOMAIN_CODE);

    alter table SMP_DOMAIN 
       add constraint UK_likb3jn0nlxlekaws0xx10uqc unique (SML_SUBDOMAIN);
create index SMP_SG_PART_ID_IDX on SMP_SERVICE_GROUP (PARTICIPANT_IDENTIFIER);
create index SMP_SG_PART_SCH_IDX on SMP_SERVICE_GROUP (PARTICIPANT_SCHEME);

    alter table SMP_SERVICE_GROUP 
       add constraint SMP_SG_UNIQ_PARTC_IDX unique (PARTICIPANT_SCHEME, PARTICIPANT_IDENTIFIER);
create index SMP_SMD_DOC_ID_IDX on SMP_SERVICE_METADATA (DOCUMENT_IDENTIFIER);
create index SMP_SMD_DOC_SCH_IDX on SMP_SERVICE_METADATA (DOCUMENT_SCHEME);

    alter table SMP_SERVICE_METADATA 
       add constraint SMP_MT_UNIQ_SG_DOC_IDX unique (FK_SG_DOM_ID, DOCUMENT_IDENTIFIER, DOCUMENT_SCHEME);

    alter table SMP_USER 
       add constraint UK_tk9bjsmd2mevgt3b997i6pl27 unique (ACCESS_TOKEN_ID);

    alter table SMP_USER 
       add constraint UK_rt1f0anklfo05lt0my05fqq6 unique (USERNAME);

    alter table SMP_ALERT_AUD 
       add constraint FKrw0qnto448ojlirpfmfntd8v2 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_ALERT_PROPERTY 
       add constraint FK15r37w3r5ty5f6074ykr2o4i6 
       foreign key (FK_ALERT_ID) 
       references SMP_ALERT (ID);

    alter table SMP_ALERT_PROPERTY_AUD 
       add constraint FKod33qjx87ih1a0skxl2sgddar 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_CERTIFICATE 
       add constraint FKayqgpj5ot3o8vrpduul7sstta 
       foreign key (ID) 
       references SMP_USER (ID);

    alter table SMP_CERTIFICATE_AUD 
       add constraint FKnrwm8en8vv10li8ihwnurwd9e 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_CONFIGURATION_AUD 
       add constraint FKd4yhbdlusovfbdti1fjkuxp9m 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_DOMAIN_AUD 
       add constraint FK35qm8xmi74kfenugeonijodsg 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_OWNERSHIP 
       add constraint FKrnqwq06lbfwciup4rj8nvjpmy 
       foreign key (FK_USER_ID) 
       references SMP_USER (ID);

    alter table SMP_OWNERSHIP 
       add constraint FKgexq5n6ftsid8ehqljvjh8p4i 
       foreign key (FK_SG_ID) 
       references SMP_SERVICE_GROUP (ID);

    alter table SMP_OWNERSHIP_AUD 
       add constraint FK1lqynlbk8ow1ouxetf5wybk3k 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_SERVICE_GROUP_AUD 
       add constraint FKj3caimhegwyav1scpwrxoslef 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_SERVICE_GROUP_DOMAIN 
       add constraint FKo186xtefda6avl5p1tuqchp3n 
       foreign key (FK_DOMAIN_ID) 
       references SMP_DOMAIN (ID);

    alter table SMP_SERVICE_GROUP_DOMAIN 
       add constraint FKgcvhnk2n34d3c6jhni5l3s3x3 
       foreign key (FK_SG_ID) 
       references SMP_SERVICE_GROUP (ID);

    alter table SMP_SERVICE_GROUP_DOMAIN_AUD 
       add constraint FK6uc9r0eqw16baooxtmqjkih0j 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_SERVICE_METADATA 
       add constraint FKfvcml6b8x7kn80m30h8pxs7jl 
       foreign key (FK_SG_DOM_ID) 
       references SMP_SERVICE_GROUP_DOMAIN (ID);

    alter table SMP_SERVICE_METADATA_AUD 
       add constraint FKbqr9pdnik1qxx2hi0xn4n7f61 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_SERVICE_METADATA_XML 
       add constraint FK4b1x06xlavcgbjnuilgksi7nm 
       foreign key (ID) 
       references SMP_SERVICE_METADATA (ID);

    alter table SMP_SERVICE_METADATA_XML_AUD 
       add constraint FKevatmlvvwoxfnjxkvmokkencb 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_SG_EXTENSION 
       add constraint FKtf0mfonugp2jbkqo2o142chib 
       foreign key (ID) 
       references SMP_SERVICE_GROUP (ID);

    alter table SMP_SG_EXTENSION_AUD 
       add constraint FKmdo9v2422adwyebvl34qa3ap6 
       foreign key (REV) 
       references SMP_REV_INFO (id);

    alter table SMP_USER_AUD 
       add constraint FK2786r5minnkai3d22b191iiiq 
       foreign key (REV) 
       references SMP_REV_INFO (id);
